Package org.apache.lucene.index

## Class ByteVectorValues

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.ByteVectorValues

- Direct Known Subclasses:
    `OffHeapByteVectorValues`, `QuantizedByteVectorValues`

      public abstract class ByteVectorValues
      extends DocIdSetIterator

  This class provides access to per-document floating point vector values indexed as `KnnByteVectorField`.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `ByteVectorValues()` | Sole constructor

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `long` | `cost()` | Returns the estimated cost of this `DocIdSetIterator`.
    `abstract int` | `dimension()` | Return the dimension of the vectors
    `abstract int` | `size()` | Return the number of vectors for this field.
    `abstract byte[]` | `vectorValue()` | Return the vector value for the current document ID.

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `advance, all, docID, empty, nextDoc, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ByteVectorValues

          protected ByteVectorValues()

      Sole constructor

  - ### Method Detail

    - #### dimension

          public abstract int dimension()

      Return the dimension of the vectors

    - #### size

          public abstract int size()

      Return the number of vectors for this field.
      Returns:
        the number of vectors returned by this iterator

    - #### cost

          public final long cost()

      Description copied from class: `DocIdSetIterator`
      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

      Specified by:
        `cost` in class `DocIdSetIterator`

    - #### vectorValue

          public abstract byte[] vectorValue()
                                      throws IOException

      Return the vector value for the current document ID. It is illegal to call this method when the iterator is not positioned: before advancing, or after failing to advance. The returned array may be shared across calls, re-used, and modified as the iterator advances.
      Returns:
        the vector value
      Throws:
        `IOException`